from collections import deque

N, M, K = map(int, input().split())
graph = {i: [] for i in range(1, N + 1)}
protected_storages = set()

for i in range(M):
    st1, st2 = map(int, input().split())
    graph[st1].append(st2)
    graph[st2].append(st1)

for i in range(K):
    guard_storage, power = map(int, input().split())
    visited = {guard_storage}
    seq = deque([(guard_storage, 0)])

    while seq:
        cur_way, cur_dist = seq.popleft()
        if cur_dist > power:
            continue
        protected_storages.add(cur_way)

        for neighbour in graph[cur_way]:
            if neighbour not in visited:
                seq.append((neighbour, cur_dist + 1))
                visited.add(neighbour)

protected_storages = sorted(protected_storages)
print(len(protected_storages))

if protected_storages:
    print(' '.join(map(str, protected_storages)))
